IF OBJECT_ID('dbo.Document') IS NULL 
	CREATE TABLE dbo.Document(idDocument  numeric(10, 0)   NOT NULL, 
						  idcatalogo      numeric(10, 0)   NOT NULL, 
						  Tipo			  Varchar(50)	   NOT NULL, 
						  Document        VARCHAR(MAX)   NOT NULL, 
						  nameDocument    varchar(300)     NULL, 
						  Dateuploaded    Datetime         NULL, 
						  useruploaded    Varchar(100)     NULL, 
						  empresa 		  int   		   NOT NULL, 
						  codigo         numeric(10, 0)   NOT NULL 
						  CONSTRAINT PKidDocument PRIMARY KEY NONCLUSTERED (idDocument) )
GO
IF OBJECT_ID('dbo.RRHHAddDocument', 'P') IS NOT NULL 
	Drop  PROCEDURE dbo.RRHHAddDocument
GO
Create PROCEDURE dbo.RRHHAddDocument
		@idcatalogo numeric(10, 0), 
		@idDocument numeric(10, 0), 
		@Tipo		Varchar(50), 
		@Document   Varchar(MAX), 
		@nameDocument varchar(300), 
		@Dateuploaded    Datetime, 
		@useruploaded    Varchar(100),
		@empresa int,
		@codigo numeric(10, 0)  
AS 
		SET NOCOUNT ON
		SET DATEFORMAT MDY
		declare @resultado varchar(10)
		Set @resultado='Error'
		if @idDocument>0
			Update dbo.Document set Tipo=@tipo, Document=@Document, nameDocument=@nameDocument, Dateuploaded=@Dateuploaded, useruploaded=@useruploaded where idDocument=@idDocument
		else
		Begin
			declare @Encontro int
			Set  @Encontro=0
			Select @Encontro=count(Document) from Document where Tipo=@tipo and idcatalogo=@idcatalogo
			--if  @Encontro>0
			--	Delete from dbo.Document where Tipo=@tipo and idcatalogo=@idcatalogo
			Insert into dbo.Document (idDocument, idcatalogo, Tipo, Document, nameDocument, Dateuploaded, useruploaded,empresa,codigo)
				Select isnull(max(idDocument),0)+1,@idcatalogo, @Tipo, @Document, @nameDocument, @Dateuploaded, @useruploaded,@empresa,@codigo from dbo.Document
			Set @resultado='Grabado'
		END
		Select @resultado as resultado
GO
IF OBJECT_ID('dbo.RRHHGetDocument', 'P') IS NOT NULL 
	Drop  PROCEDURE dbo.RRHHGetDocument
GO
Create PROCEDURE dbo.RRHHGetDocument
	@idcatalogo numeric(10, 0), 
	@idDocument numeric(10, 0), 
    @Tipo		Varchar(50), 
	@empresa int,
	@codigo numeric(10, 0),
	@archivo int 
AS 
    SET NOCOUNT ON
	SET DATEFORMAT MDY
    DECLARE @selectClause AS NVARCHAR(4000)
    DECLARE @whereClause AS VARCHAR(1024)
    DECLARE @orderByClause AS VARCHAR(512)
    DECLARE @debugFlag AS NUMERIC(1, 0)
    DECLARE @whereClauseUsed AS NUMERIC(1, 0)
	DECLARE @totalRecords AS INTEGER
    SET XACT_ABORT ON
        -- Set the debug flag
    SET @debugFlag = 0
        
        -- Initialize the local variables
    SET @whereClause = ''
    SET @orderByClause = ''
    SET @whereClauseUsed = 0
        
        -- Count all the existing records
    SET @selectClause = 'SELECT COUNT(*) FROM [dbo].[Document] '
        -- Search criteria: @empresa
    IF @empresa > 0 
        BEGIN    
            IF @whereClauseUsed = 0 
                BEGIN
               
                    SET @whereClause = @whereClause + 'WHERE '
                    SET @whereClauseUsed = 1
    
                END
            ELSE 
                SET @whereClause = @whereClause + ' AND '
                         
            SET @whereClause = @whereClause + ' empresa = '
                + LTRIM(RTRIM(STR(@empresa)))
                 
        END

        -- Search criteria: @idcatalogo
    IF @idcatalogo > 0 
        BEGIN    
            IF @whereClauseUsed = 0 
                BEGIN
               
                    SET @whereClause = @whereClause + 'WHERE '
                    SET @whereClauseUsed = 1
    
                END
            ELSE 
                SET @whereClause = @whereClause + ' AND '
                         
            SET @whereClause = @whereClause + ' idcatalogo = '
                + LTRIM(RTRIM(STR(@idcatalogo)))
                 
        END
        -- Search criteria: @codigo
    IF @codigo > 0 
        BEGIN    
            IF @whereClauseUsed = 0 
                BEGIN
               
                    SET @whereClause = @whereClause + 'WHERE '
                    SET @whereClauseUsed = 1
    
                END
            ELSE 
                SET @whereClause = @whereClause + ' AND '
                         
            SET @whereClause = @whereClause + ' codigo = '
                + LTRIM(RTRIM(STR(@codigo)))
                 
        END

        -- Search criteria: @idDocument
    IF @idDocument > 0 
        BEGIN    
            IF @whereClauseUsed = 0 
                BEGIN
               
                    SET @whereClause = @whereClause + 'WHERE '
                    SET @whereClauseUsed = 1
    
                END
            ELSE 
                SET @whereClause = @whereClause + ' AND '
                         
            SET @whereClause = @whereClause + ' idDocument = '
                + LTRIM(RTRIM(STR(@idDocument)))
                 
        END

        -- Search criteria: @Tipo
    IF len(@Tipo) > 0 
        BEGIN    
            IF @whereClauseUsed = 0 
                BEGIN
               
                    SET @whereClause = @whereClause + 'WHERE '
                    SET @whereClauseUsed = 1
    
                END
            ELSE 
                SET @whereClause = @whereClause + ' AND '
                         
            SET @whereClause = @whereClause + ' Tipo = '
                + LTRIM(RTRIM(@Tipo))
                 
        END

    CREATE TABLE #contratosCounter ( TotalRecords INTEGER )
        
    IF @debugFlag = 1 
        SELECT  @selectClause + @whereClause
    ELSE 
        INSERT  INTO #contratosCounter
                EXECUTE ( @selectClause + @whereClause
                       )
    
        -- Set the total records indicador
    SELECT TOP 1
            @totalRecords = TotalRecords
    FROM    #contratosCounter
    SET @totalRecords = ISNULL(@totalRecords, 0)
    SET @whereClauseUsed = 0
        
    DROP TABLE #contratosCounter
	if @archivo>0
		SET @selectClause = 'SELECT idDocument, idcatalogo, Tipo, Document, nameDocument, Dateuploaded, useruploaded, empresa, codigo,'+ LTRIM(RTRIM(STR(@totalRecords)))+' as totalRecords FROM [dbo].[Document] '
	else
		SET @selectClause = 'SELECT idDocument, idcatalogo, Tipo, '' '' as Document, nameDocument, Dateuploaded, useruploaded, empresa, codigo,'+ LTRIM(RTRIM(STR(@totalRecords)))+' as totalRecords FROM [dbo].[Document] '

    IF @debugFlag = 1 
        SELECT  @selectClause + @whereClause
    ELSE 
		if @totalRecords>0
			EXECUTE ( @selectClause + @whereClause + 'Order by  empresa, codigo,Tipo ')
		else
			Select 0 as totalRecords

GO 
Print 'ok'
GO